#ifndef UBlasBasics_hh
#define UBlasBasics_hh

//#include <boost/numeric/ublas/blas.hpp>

#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/matrix_sparse.hpp>
#include <boost/numeric/ublas/matrix_proxy.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/vector_proxy.hpp>
#include <boost/numeric/ublas/symmetric.hpp>
#include <boost/numeric/ublas/io.hpp>
#include <boost/numeric/ublas/operation.hpp>

using namespace boost::numeric::ublas;


/**
 * Normal matrix
 */
typedef matrix<double, column_major> Matrix;

/**
 * Symmetric matrix, mostly for least squares stuff.
 */
typedef symmetric_matrix<double, lower, column_major> SymmetricMatrix;

/**
 * Mapped Matrix for sparse data.
 */
typedef mapped_matrix<double, column_major> SparseMatrix;

/**
 * Normal vector
 */
typedef boost::numeric::ublas::vector<double> Vector;

/**
 * Diagonal matrix
 */
typedef banded_matrix<double> Diagonal; 



#endif
