#ifndef ManyToOneControllerMinUpdates_hh
#define ManyToOneControllerMinUpdates_hh
// $Id: ManyToOneControllerMinUpdates.hh 29 2006-12-19 02:16:20Z daa $

namespace libpg {

/**
 * A controller that is really a collection of other controllers. This
 * controller simply fields observations to all controllers, and
 * gathers back a single dimension action from each of them.
 */

class ManyToOneControllerMinUpdates : public ManyToOneController {


public:

    double discount;

    Vector* eligible;
    int currentTime;
    Vector lastUpdateTime;

    ManyToOneControllerMinUpdates(Approximators approximators, bool splitObs, bool localRewards);

    /**
     * Where the real coding is done to implement 
     */
    virtual void getAction(Observation& obs, Vector& action, bool computeGrad = true);

    virtual void discountTrace();
    virtual void setDiscount(double discount);
    virtual void instantStep(Vector& rewards);
    virtual void resetTrace();

};
}
#endif
