#ifndef NeuralNetBatch_hh
#define NeuralNetBatch_hh
// $Id: NeuralNetBatch.hh 29 2006-12-19 02:16:20Z daa $

namespace libpg {
/**
 * A version of neural network that supports aggregated gradients
 */

class NeuralNetBatch : public NeuralNet {

public:

    Matrix* grads;

    
    NeuralNetBatch(Vector& dims, Vector& squash);
    NeuralNetBatch(int in, int out);

    virtual void batchStep();
    virtual void computeDirection(int steps);
    virtual void accumulateGrad(double reward, Observation& newObs);
    virtual void resetGrad();


    virtual void reduce(Vector& v, StatsEnum s);
    virtual void scatter(Vector& v, StatsEnum s);

};
}
#endif
