#include "PGBasics.hh"

namespace libpg {

Observation::Observation(int rows, int cols, int agents) {

    init(rows, cols, agents);

}


/**
 * Copy constructor
 */
Observation::Observation(Observation& obs) {

    *this = obs;
}


Observation& Observation::operator=(Observation& rhs) {
    if (&rhs != this) {
	features = rhs.getFeatures();
	eligible = rhs.getEligible();
	agent = rhs.getAgent();
	steps = rhs.getSteps();
    }
    return *this;
}


void Observation::init(int rows, int cols, int agents) {

  // Arbitrary matrix
  features.resize(rows, cols);

  // Default number of agents is number of cols, might not actually be
  // used.
  eligible.resize(agents);
  eligible.clear();
  
  // This is initialised to all ones so that the default behaviour is
  // to run all agents. This means that if you don't know anything
  // about the eligible vector you should still get the expected
  // behaviour. I.e., you have to manually turn off agents, not
  // manually turn them on!
  for (Vector::iterator i = eligible.begin(); i != eligible.end(); i++) *i=1.0;

  agent=0; // Default to first obs, always. Might not be used.

  steps=0;

}
}
