using namespace std;

#include"PGBasics.hh"
#include "definitions.hh"
#include "intersection.hh"
#include"FixedController.hh"

using namespace libpg;
   
FixedController::FixedController(int no_inputs, int NS_length,
		       int NSR_length, int EW_length, int EWR_length) : 
    inputs(no_inputs) {
    duration = -1;
    current_phase = 0;
    phase_length[Intersection::NS_straight] = NS_length; 
    phase_length[Intersection::NS_right] = NSR_length; 
    phase_length[Intersection::EW_straight] = EW_length; 
    phase_length[Intersection::EW_right] = EWR_length; 
}

void FixedController::getAction(Observation& obs, Vector& action, 
				bool computeGrad) {   
  assert(action.size() == 1);
  /*
  if(obs.agent == 1) {
    cout << "current phase: " << current_phase << ", duration: " << duration << ", comp to: "
	 << (phase_length[current_phase] - 1) << endl;
  }
  */
  if(duration < (phase_length[current_phase] - 1)) {
    action[0] = 0; // no switch 
    duration++;
  }
  else {
    action[0] = 1; // switch 
    current_phase = (current_phase + 1) % PHASES;
    duration = 0;
  }
}

// not needed at the moment, return something
int FixedController::getInputDim() {
    return inputs;
}

void FixedController::resetParams() { 
}

void FixedController::randomizeParams() { 
  NYI; 
}

void FixedController::write(ostream& o) { 
  for(int i = 0; i < PHASES; i++) {
    o << phase_length[i] << endl;
  }
};  

void FixedController::read(istream& o) {
  
  //cout << "reading settings" << endl;
  for(int i = 0; i < PHASES; i++) {
    o >> phase_length[i];
    //cout << "read phase_length["<< i<< "]: "<< phase_length[i] << endl;
  }
};

