#include"PGBasics.hh"
#include "definitions.hh"
#include "intersection.hh"
#include"FixedRPController.hh"

using namespace libpg;

   
FixedRPController::FixedRPController(int no_inputs, std::vector<int>& phase_commands) : 
  inputs(no_inputs), phases(phase_commands) {
  time = 0;
}

void FixedRPController::getAction(Observation& obs, Vector& action, 
				bool computeGrad) {   
  assert(action.size() == 1);
  
  /*
  if(obs.agent == 1) {
    cout << "time: " << time << endl;
    cout << ", next phase: " << phases.at(time) << endl;
  }
  */

  action[0] = phases.at(time); // no switch 
    time = (time + 1) % phases.size();
 
}

// not needed at the moment, return something
int FixedRPController::getInputDim() {
    return inputs;
}

void FixedRPController::resetParams() { 
}

void FixedRPController::randomizeParams() { 
  NYI; 
}

void FixedRPController::write(ostream& o) { 
  for(int i = 0; i < (signed int) phases.size(); i++) {
    o << phases[i] << endl;
  }
};  

void FixedRPController::read(istream& o) {
  
  //cout << "reading settings" << endl;
  for(int i = 0; i < (signed int) phases.size(); i++) {
    o >> phases[i];
    //cout << "read phase command["<< i<< "]: "<< phases[i] << endl;
  }
};

