#ifndef SCNEARIO_HH
#define SCNEARIO_HH

//typedef list<Car*> CarList;
typedef std::vector<Intersection*> IntersectionVec;
class STS;

class Scenario {

public:
  enum ScenarioEnum {EW_BIASED, RANDOM, SUDDEN_INFLUX, 
		     EW_BIASED_CENTER_ONLY,
		     ONE_ROW_OFFSET_TEST,
		     SINUSOIDAL, MAIN_STREET, BIG_GRID};
  //Scenario(CarList the_cars, IntersectionVec the_intersections);
  Scenario(int rows, int cols);
  //virtual ~Scenario() {}

  //IntersectionVec intersections;
  //int no_intersections;
  //IntersectionVec get_intersections() {return intersections;} //TODO: return ref
  //CarList& get_cars() {return cars;}
  int get_rows() {return grid_rows;}
  int get_cols() {return grid_cols;}
    
  void make_intersections(IntersectionVec& intersections, int rows, int cols);
  void produce_cars(STS* sts); 

private:

  int grid_rows;
  int grid_cols;

  // data structures for big grid scenario
  std::vector<int> big_grid_first_dest;
  std::vector<int> big_grid_second_dest;
  std::vector<double> big_grid_first_prob;
  std::vector<double> big_grid_second_prob;

  void big_grid_initialize(); 

  // intersection creation functions
  void make_intersection_grid(IntersectionVec& intersections, int rows, int cols);
  void make_intersection_cross(IntersectionVec& intersections, int rows, int cols);
  void make_intersection_row(IntersectionVec& intersections, int rows, int cols);
  void make_main_street_intersections(IntersectionVec& intersections);


  // car producing functions
  void produce_sudden_influx_cars(STS* sts, int num);
  void produce_random_cars(STS* sts, int num);
  void produce_EW_biased_cars(STS* sts, int num, bool center_only);
  void one_row_offset_test(STS* sts, int num);
  void sinusoidal(STS* sts, int num); 
  void main_street(STS* sts, int num);
  void big_grid(STS* sts);
};

#endif
