#ifndef CRFCross_hh
#define CRFCross_hh


namespace tree_mcmc {

class CRFCross : public CRFExact
{

protected:

	int num_row;				// number of rows, only for grid
	int num_col;				// number of columns, only for grid
	int num_cross_upper;		// how many nodes are there above the horizontal chain?
	int cross_hori_id;			// cross at which horizontal node?

protected:

	virtual void alloc_adj_matrix();
	virtual void associate_edge_with_nodes();
	virtual int get_edge_id(int node1, int node2);
//	virtual void define_partitions();

public:

	CRFCross(int *argc, char** argv);

	virtual void fill_edge_reward(double *reward);

	/**
	 *	Set up the parameters, the adjacency matrix
	 */
	virtual void init_graph(int *argc, char **argv);

};

}

#endif
