#ifndef CRFGrid_hh
#define CRFGrid_hh


namespace tree_mcmc {

class CRFGrid : public CRFApprox
{

protected:

	int num_row;				
	int num_col;				

protected:

	virtual void alloc_adj_matrix();
	virtual void associate_edge_with_nodes();
	
	virtual int get_edge_id(int node1, int node2);
	virtual void define_partitions();

public:

	CRFGrid(int *argc, char** argv);

	/**
	 *	Set up the parameters, the adjacency matrix
	 */
	virtual void init_graph(int *argc, char **argv);
	virtual void cal_fea_expectation() = 0;
	virtual void fill_trace() = 0;
	virtual void fill_edge_reward(double *reward);
	virtual void set_potentials() = 0;

};

}

#endif
